/*
 
 File:		IBVASerialPortOutPlugIn.h
 
 Contains:	IBVASerialPortOutPlugIn
 
 Version:	IBVA V4.5.8 + IBVASerialPortOutPlugIn V1.0
 
 Copyright:	masahiro kahata & Psychic Lab Inc. all rights reserved.
 
 File Ownership:
 
 DRI:				masahiro kahata
 
 Contact:			m@psychiclab.net          masahiro@psychiclab.net       contact@psychiclab.net
 Technology:			http://psychiclab.net      http://www.psychiclab.net
 
 Writers:
 
 (cjd)	masahiro kahata
 
 
 
 //
 //
 // this code open for help
 // people who try to change this world more nice way for us specially people who doing ufo, psychic, psychotronics, crop circle, free energy research and open information act.
 // people who is working this way can use this code for there own purpose with no permission from me with there own risk.
 //
 //
 //
 // IBVA code development short history
 //
 // <IBVA V1.0 beta> 17 oct 1987 : start develop IBVA
 // <IBVA V1.6 beta> 21 oct 1988 : pre prototype
 // <IBVA V1.0> 6 nov 1989 : prototype
 // <IBVA V1.0.2> apr 1991 : start to ship in Japan
 // <IBVA V1.0.5> 5 jan 1992 : start to ship in USA
 // <IBVA V1.8.7>  13 feb 1999 : 68K Think Project Manager 7.0.4
 // <IBVA V2.0.9> 23 jan 2000 : starsBrain & brain skyfly
 // <IBVA V2.3.2> 15 dec 2000 : IDE V4.1, CW V6
 // <IBVA V3.0.0> 26 Sep 2003 : new Icon
 // <IBVA V3.5.0> 29 Nov 2003 : start to use XCODE. V1 prototype Bluetooth IBVA
 // <IBVA V3.6.0> 29 Apr 2004 : V2 prototype Bluetooth IBVA
 // <IBVA V4.0.0> 1 Mar 2005 : Core-MIDI 
 // <IBVA V4.1.0> 17 May 2005 : start to ship IBVA4. XCODE1.5
 // <IBVA V4.1.1> 29 July 2005 : XCODE2.0, Tiger
 // <IBVA V4.1.3> 19 Sep 2005 : XCODE2.2. Quartz Composer Plugin
 // <IBVA V4.2.0> 1 March 2006 : V3 prototype Bluetooth IBVA
 // <IBVA V4.2.6> 5 May 2006 : final prototype Bluetooth IBVA
 // <IBVA V4.4.0> 19 Mar 2007 : XCODE2.4.1.  MIDI play with 0.01 second timing with live video and brain wave recording.
 // <IBVA V4.5.4> 26 Oct 2007 : XCODE3. Leopard.
 // <IBVA V4.5.8> 23 Dec 2007 : QC V3 + XCODE3 + Leopard.
 //
 //
 // this source code is based on my over 35 years of ufo, psychic, dream and brain wave interaction experience, dream and brain wave data analysis & research.
 // thanks to 
 // ayumi, masachan-etsuchan, hiyori, l-chi, paras,
 // alien, beings who working for this planet, this stars system and other stars system,
 // hyper space time dimensions + psychic dimension & dream dimension.
 //
 // need more this kind of experience & research.
 //
 // i need more help to keep continue to do this kind of things,
 // i like happy family, easy way and fun to make it. 
 // need psychic healing,,,
 // need experience for dream, remote viewing, telepathy, psychic, 
 // crop circle, ufo and alien abductee, alien implant, etc....
 */ 




#import <Quartz/Quartz.h>




@interface IBVASerialPortOutPlugIn : QCPlugIn
{
	NSString*					text;
 	NSTimer* timerX;
 	NSTimer* timer;
	
	
	BOOL inputAutoIphoneConnectionX;
	
    double     eyePeakLX, deltaPeakLX, thetaPeakLX, 
	alphaPeakLX, lowbetaPeakLX, midbetaPeakLX, 
	highbetaPeakLX, acPeakLX, gammaPeakLX;
	
	double     outputPeakVLX, outputPeakFLX, outputPeakVRX, outputPeakFRX;
    double     outputPeakVL2X, outputPeakFL2X, outputPeakVR2X, outputPeakFR2X;
	
	//
	//
	//
	//	Picker*				_picker;
//	TCPServer*			_server;
//	NSInputStream*		_inStream;
//	NSOutputStream*		_outStream;
	BOOL				_inReady;
	BOOL				_outReady;
	//
	IBOutlet NSTextField * 	displayHeresoundName;
    IBOutlet NSTextField * 	displayHereHostName;
    IBOutlet NSTextField * 	displayHereConnectionName;
	//	
	float VolumeSlider_value;
	float TimeSlider_value;
	float SpeedSlider_value;
	float UseBSSlider_value;
	float OnOffSWBSSlider_value;
	float UseFBSSlider_value;
	float EyedeltaLSlider_value;
	float EyedeltaHSlider_value;
	float ThetaLSlider_value;
	float ThetaHSlider_value;
	float AlphaLSlider_value;
	float AlphaHSlider_value;
	float BetaLSlider_value;
	float BetaHSlider_value;
	
	float XSlider_value;
	float YSlider_value;
	float ZSlider_value;
	
}

/* Declare an internal setting as a property of type NSString* */

@property(copy) NSString* text;



@property BOOL inputAutoIphoneConnection;
/* Declare a property input port of type "Boolean" and with the key "inputMultiPeakPowerTriger" */
@property BOOL inputXYZBSiPhone;
@property BOOL inputTouchBSiPhone;
@property NSUInteger inputChannel;

/* Declare a property input port of type "Boolean" and with the key "inputMultiPeakPowerTriger" */
@property NSUInteger inputBPSMode;
@property NSUInteger inputOutputBSMode;

/* Declare a property input port of type "Index" and with the key "inputDataBitMode" */
@property double inputDataBitMode;


/* Declare a property input port of type "Boolean" and with the key "inputEnable" */
@property BOOL inputUpdate;

@property(assign) NSString* outputIPhoneConnectionString;

@property(assign) NSString* outputString;

@property BOOL outputVolumeUp;
@property BOOL outputVolumeDown;
@property BOOL outputPrevious;
@property BOOL outputNext;
@property BOOL outputPlay;
@property BOOL outputMenu;
@property BOOL outputBegin;
@property BOOL outputStop;

@property double outputPeakVR2;
@property double outputPeakFR2;
@property double outputPeakVL2;
@property double outputPeakFL2;

@property double outputPeakVR;
@property double outputPeakFR;
@property double outputPeakVL;
@property double outputPeakFL;


@property double outputBS8L;
@property double outputBS7L;
@property double outputBS6L;
@property double outputBS5L;
@property double outputBS4L;
@property double outputBS3L;
@property double outputBS2L;
@property double outputBS1L;



- (void)initializeThred;
- (void)runSecondarySerialThread:(id)ignoredObject;;
- (void) timerUpdate : (NSTimer*) sender;


- (void) dealloc;


@end


