/*
 
 File:		IBVASerialPortPlugIn.m
 
 Contains:	IBVASerialPortPlugIn
 
 Version:	IBVA V4.5.8 + IBVASerialPortPlugIn V1.0
 
 Copyright:	masahiro kahata & Psychic Lab Inc. all rights reserved.
 
 File Ownership:
 
 DRI:				masahiro kahata
 
 Contact:			m@psychiclab.net          masahiro@psychiclab.net       contact@psychiclab.net
 Technology:			http://psychiclab.net      http://www.psychiclab.net
 
 Writers:
 
 (cjd)	masahiro kahata
 
 
 
 //
 //
 // this code open for help
 // people who try to change this world more nice way for us specially people who doing ufo, psychic, psychotronics, crop circle, free energy research and open information act.
 // people who is working this way can use this code for there own purpose with no permission from me with there own risk.
 //
 //
 //
 // IBVA code development short history
 //
 // <IBVA V1.0 beta> 17 oct 1987 : start develop IBVA
 // <IBVA V1.6 beta> 21 oct 1988 : pre prototype
 // <IBVA V1.0> 6 nov 1989 : prototype
 // <IBVA V1.0.2> apr 1991 : start to ship in Japan
 // <IBVA V1.0.5> 5 jan 1992 : start to ship in USA
 // <IBVA V1.8.7>  13 feb 1999 : 68K Think Project Manager 7.0.4
 // <IBVA V2.0.9> 23 jan 2000 : starsBrain & brain skyfly
 // <IBVA V2.3.2> 15 dec 2000 : IDE V4.1, CW V6
 // <IBVA V3.0.0> 26 Sep 2003 : new Icon
 // <IBVA V3.5.0> 29 Nov 2003 : start to use XCODE. V1 prototype Bluetooth IBVA
 // <IBVA V3.6.0> 29 Apr 2004 : V2 prototype Bluetooth IBVA
 // <IBVA V4.0.0> 1 Mar 2005 : Core-MIDI 
 // <IBVA V4.1.0> 17 May 2005 : start to ship IBVA4. XCODE1.5
 // <IBVA V4.1.1> 29 July 2005 : XCODE2.0, Tiger
 // <IBVA V4.1.3> 19 Sep 2005 : XCODE2.2. Quartz Composer Plugin
 // <IBVA V4.2.0> 1 March 2006 : V3 prototype Bluetooth IBVA
 // <IBVA V4.2.6> 5 May 2006 : final prototype Bluetooth IBVA
 // <IBVA V4.4.0> 19 Mar 2007 : XCODE2.4.1.  MIDI play with 0.01 second timing with live video and brain wave recording.
 // <IBVA V4.5.4> 26 Oct 2007 : XCODE3. Leopard.
 // <IBVA V4.5.8> 23 Dec 2007 : QC V3 + XCODE3 + Leopard.
 //
 //
 // this source code is based on my over 35 years of ufo, psychic, dream and brain wave interaction experience, dream and brain wave data analysis & research.
 // thanks to 
 // ayumi, masachan-etsuchan, hiyori, l-chi, paras,
 // alien, beings who working for this planet, this stars system and other stars system,
 // hyper space time dimensions + psychic dimension & dream dimension.
 //
 // need more this kind of experience & research.
 //
 // i need more help to keep continue to do this kind of things,
 // i like happy family, easy way and fun to make it. 
 // need psychic healing,,,
 // need experience for dream, remote viewing, telepathy, psychic, 
 // crop circle, ufo and alien abductee, alien implant, etc....
 */ 



/* It's highly recommended to use CGL macros instead of changing the current context for plug-ins that perform OpenGL rendering */

#include <Carbon/Carbon.h>

#import "IBVASerialPortPlugIn.h"
#import "RFCOMMSPPController.h"

#import <OpenGL/CGLMacro.h>


#define	MAXPATHLEN 1024

#define	kQCPlugIn_Name				@"IBVAplugin OpenGL"
#define	kQCPlugIn_Description		@"IBVA Plugin. Output Update: This trigger update output.  Output Gain: All Output Gain setup.  Output Mode: Set Output Mode. Direct 0..255, Normalize by 255:0..360, Normalize by 255:-360..360, Normalize by 255:0..1, Normalize by Max X,Y,Z:0..1, Key String Output: String Output, Char Output: Character Output, X,Y,Z: X, Y, Z Output.  Control: Control Output.  Speed:Speed Output.  Volume:Volume Output.  Volume Up, Volume Down, Previous, Next, Play, Menu, Begin, Stop Signal: each Signal Output."


#define true 1
#define false 0



//
//
//
extern int mainSerialIBVA0(void);
extern int mainSerialIBVA1(char *portName);
extern int mainSerialIBVA2(char *inputText);
extern int mainSerialIBVA3(void);
//
extern kern_return_t FindModems(io_iterator_t *matchingServices);
extern kern_return_t GetModemPath(io_iterator_t serialPortIterator, char *bsdPath, CFIndex maxPathSize, int selectmodemN);

//
//



int firsttimestartmainloop=1;
int firstTimeRun=1;
//
int charP=0;
int	nextCharP=1;
//
char Cstr[256];
//
BOOL inputPortS;
char bufferInputCX[1024];
char bufferInputCX1[1024];
char bufferInputCX2[64000];
char bufferInputCX2A[64000];
char bufferInputCX2B[64000];
char bufferInputCX2C[64000];
char bufferInputCX2D[64000];
//
int SendText=1;

int OutportDatabit=2;
int OutportParity=0;
int OutportCTSflowControl=0;
//
int numberOfPort=1;
extern int			modemN;
char strAllport[12][1024]; // max port number : 12, eah max char : 1024
char strAllportName[12][1024];
char bsdPathZ[1024];
char bsdPathX[1024];
//
NSString *str1, *str2, *str3, *str4, *str5, *str6, *str7, *str8, *str9, *str10, *str11, *str12;

//
extern unsigned char *dataAsBytes;
unsigned char *dataAsBytesXYZ;
//
//
extern unsigned char	bufferX[];
int bufferXcount=0;
int bufferXcountB=0;
int bufferXcountB1=0;
int bufferXcountB2=0;
int bufferXcountB3=0;
int bufferXcountB4=0;
//
//
//
int DelimiterX;
int OutputFormatX;
//
//
//


@implementation IBVASerialPortPlugIn

/* We need to declare the input / output properties as dynamic as Quartz Composer will handle their implementation */
@dynamic
inputX, inputY, inputColor, inputImage, inputDelimiter, inputOutputFormat, inputSendText, inputPortON, inputUpdate,
outputDString, outputCString, outputBString, outputAString, outputString, outputStringPort, outputPortNumber;


/* The "text" property must be synthesized */
@synthesize text;


+ (id)sharedIBVASerialPortPlugIn {
    static IBVASerialPortPlugIn *sharedIBVASerialPortPlugIn = nil;
	
    if (!sharedIBVASerialPortPlugIn) {
        sharedIBVASerialPortPlugIn = [[IBVASerialPortPlugIn allocWithZone:NULL] init];
    }
	
    return sharedIBVASerialPortPlugIn;
}





+ (NSDictionary*) attributes
{
	/* Return the attributes of this plug-in */
	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary*) attributesForPropertyPortWithKey:(NSString*)key
{

	printf("attributesForPropertyPortWithKey\n");

	NSArray *titlesOutputFormat = [NSArray arrayWithObjects:
							  @"hex",
							  @"0000 .. 1023",
							  @"-100.0 .. 100.0",
							  nil];
	
	NSArray *titlesDelimiter = [NSArray arrayWithObjects:
								  @"tab",
								  @"space",
								  @":",
								  nil];
	
	//
	//
	//
	/* Return the attributes for the plug-in property ports */
	if([key isEqualToString:@"inputX"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"X Position", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"inputY"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Y Position", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"inputColor"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Color", QCPortAttributeNameKey, nil];
	if([key isEqualToString:@"inputImage"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Image", QCPortAttributeNameKey, nil];
	
	//
	//
	//

	if([key isEqualToString:@"inputUpdate"])
		return [NSDictionary dictionaryWithObject:@"Output Update" forKey:QCPortAttributeNameKey];

	if([key isEqualToString:@"inputPortON"])
		return [NSDictionary dictionaryWithObject:@"Port ON" forKey:QCPortAttributeNameKey];

	if([key isEqualToString:@"inputSendText"])
		return [NSDictionary dictionaryWithObject:@"Send Text" forKey:QCPortAttributeNameKey];
//
	//
	//
	if([key isEqualToString:@"inputDelimiter"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Delimiter", QCPortAttributeNameKey, [NSNumber numberWithUnsignedInteger:3], QCPortAttributeMaximumValueKey, [NSNumber numberWithUnsignedInteger:0], QCPortAttributeDefaultValueKey, [NSArray arrayWithArray:titlesDelimiter], QCPortAttributeMenuItemsKey,  nil];
	
 	if([key isEqualToString:@"inputOutputFormat"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Output Format", QCPortAttributeNameKey, [NSNumber numberWithUnsignedInteger:3], QCPortAttributeMaximumValueKey, [NSNumber numberWithUnsignedInteger:0], QCPortAttributeDefaultValueKey, [NSArray arrayWithArray:titlesOutputFormat], QCPortAttributeMenuItemsKey,  nil];

	//
	//
	//
	//
	if([key isEqualToString:@"outputString"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"String Output", QCPortAttributeNameKey, nil];
	//
	//
	if([key isEqualToString:@"outputStringPort"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Port name", QCPortAttributeNameKey, nil];

	//
	//
	if([key isEqualToString:@"outputPortNumber"])
		return [NSDictionary dictionaryWithObjectsAndKeys:@"Port Number", QCPortAttributeNameKey, nil];



	
	
	return nil;
}

+ (QCPlugInExecutionMode) executionMode
{
	/* This plug-in is a processor */
	return kQCPlugInExecutionModeProcessor;
}

+ (QCPlugInTimeMode) timeMode
{
	/* This plug-in does not depend on the time (time parameter is completely ignored in the -execute:atTime:withArguments: method) */
	return kQCPlugInTimeModeNone;
}







- (id) init
{
	printf("init\n");
	
	
	if(self = [super init]) {
		/* Set a default value for our internal setting */
		self.text = @"Bonjour";
	}


	//
	// this case max numberOfPort is 12
	//
	
	numberOfPort=[self setGetINPort:1];
	printf("numberOfPort init %d\n", numberOfPort);
	
	NSArray *titlesPortName;

	if (numberOfPort==0)	{
		titlesPortName = [NSArray arrayWithObjects:
						  nil];
	}
	else if (numberOfPort==1)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   nil];
	}
	else if (numberOfPort==2)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   str2,
								   nil];
	}
	else if (numberOfPort==3)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   str2,
								   str3,
								   nil];
	}
	else if (numberOfPort==4)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   str2,
								   str3,
								   str4,
								   nil];
	}
	else if (numberOfPort==5)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   str2,
								   str3,
								   str4,
								   str5,
								   nil];
	}
	else if (numberOfPort==6)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   str2,
								   str3,
								   str4,
								   str5,
								   str6,
								   nil];
	}
	else if (numberOfPort==7)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   str2,
								   str3,
								   str4,
								   str5,
								   str6,
								   str7,
								   nil];
	}
	else if (numberOfPort==8)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   str2,
								   str3,
								   str4,
								   str5,
								   str6,
								   str7,
								   str8,
								   nil];
	}
	else if (numberOfPort==9)	{
		titlesPortName = [NSArray arrayWithObjects:
								   str1,
								   str2,
								   str3,
								   str4,
								   str5,
								   str6,
								   str7,
								   str8,
									str9,
								   nil];
	}
	else if (numberOfPort==10)	{
		titlesPortName = [NSArray arrayWithObjects:
						  str1,
						  str2,
						  str3,
						  str4,
						  str5,
						  str6,
						  str7,
						  str8,
						  str9,
						  str10,
						  nil];
	}
	else if (numberOfPort==11)	{
		titlesPortName = [NSArray arrayWithObjects:
						  str1,
						  str2,
						  str3,
						  str4,
						  str5,
						  str6,
						  str7,
						  str8,
						  str9,
						  str10,
						  str11,
						  nil];
	}
	else if (numberOfPort==12)	{
		titlesPortName = [NSArray arrayWithObjects:
						  str1,
						  str2,
						  str3,
						  str4,
						  str5,
						  str6,
						  str7,
						  str8,
						  str9,
						  str10,
						  str11,
						  str12,
						  nil];
	}
	
// 	[self removeInputPortForKey:[NSString stringWithFormat:@"inputSerialPortName"]];
 	[self addInputPortWithType:QCPortTypeIndex forKey:[NSString stringWithFormat:@"inputSerialPortNameX"] withAttributes:[NSDictionary dictionaryWithObjectsAndKeys:@"Port Selection", QCPortAttributeNameKey, [NSNumber numberWithUnsignedInteger:numberOfPort], QCPortAttributeMaximumValueKey, [NSNumber numberWithUnsignedInteger:0], QCPortAttributeDefaultValueKey, [NSArray arrayWithArray:titlesPortName], QCPortAttributeMenuItemsKey,  nil]];


	
	return self;
}

- (void) dealloc
{
	/* IMPORTANT: We need to set the property for our internal setting to nil on -dealloc or the property value will leak */
	self.text = nil;
	
	[super dealloc];
}


 /*
 + (NSArray*) plugInKeys
 {
	// Return the list of KVC keys corresponding to our internal settings  
	return [NSArray arrayWithObject:@"text"];
 }

 - (QCPlugInViewController*) createViewController
 {
	// Create a QCPlugInViewController to handle the user-interface to edit the our internal settings 
	return [[QCPlugInViewController alloc] initWithPlugIn:self viewNibName:@"SimpleTextSettings"];
 }
*/
 

- (void)initializeThred
{
	if (firstTimeRun)	{
		[NSThread detachNewThreadSelector:@selector(runSecondarySerialThread:) toTarget:self withObject:nil];
		firstTimeRun=0;
	}
	
	
	//	[self init];
}

- (void)runSecondarySerialThread:(id)ignoredObject;
{
    NSAutoreleasePool *pool;
	
    pool = [[NSAutoreleasePool alloc] init];
	
 //  	timerX = [NSTimer timerWithTimeInterval:0.015f target:self selector:@selector(timerUpdate:) userInfo:nil repeats:YES];
//	[[NSRunLoop currentRunLoop] run];
	
    [pool release];
	
}

- (void) timerUpdate : (NSTimer*) sender	{
	
	
	
}



- (int) setGetINPort: (int) state
{
	int i,j;
	int findPortCount = 0;
	int  findPortCountX = 0;
//	NSString *str1, *str2, *str3, *str4, *str5, *str6, *str7, *str8, *str9, *str10, *str11, *str12;
    char *bytes;
	register int length;
#define BufferSize 1000
	//     CFMutableStringRef mutStr;
	//     UniChar *myBuffer;
//	char *bsdPathX;
	
	
	str1 = str2 = str3 = str4 = str5 = str6 = str7 = str8 = str9 = str10 = str11 = str12 = @"no port";

	printf("inside setGetINPort\n");	

	
  	findPortCount =  [self SerialGetPort:100 CH:bsdPathZ]; // find all port then show last one
	//  	findPortCount =  [[AMSerialPort sharedAMSerialPort] SerialGetPort:100 CH:bsdPathX]; // find all port then show last one

// 	findPortCount=3;
	
	printf("total Port number : %d\n", findPortCount);	
	
	//     myBuffer = CFAllocatorAllocate(CFAllocatorGetDefault(), 32 * sizeof(UniChar), 0);
	//     mutStr = CFStringCreateMutableWithExternalCharactersNoCopy(NULL, myBuffer, 0, 32, NULL);
	
	//     CFStringAppend(mutStr, CFSTR("total Port number : "));
	//     CFStringAppendFormat(mutStr, NULL, CFSTR("%d"), findPortCount );
	//  	[[self displayINPortField] setStringValue:(NSString*)mutStr  ];  
	
	//     CFRelease(mutStr);
	
	
	
	
  	for (i=1; i<findPortCount+1; i++) // all  print
  	{
		findPortCountX =  [self SerialGetPort:i CH:bsdPathZ];	// when 1 then 1st one, 
		printf("findPortCountX in setGetINPort: %d\n", findPortCountX);
		//		findPortCountX =  [[AMSerialPort sharedAMSerialPort] SerialGetPort:i CH:bsdPathX];	// when 1 then 1st one, 
		if (findPortCountX ==  i) 
		{
			bytes = CFAllocatorAllocate(CFAllocatorGetDefault(), 64 * sizeof(UniChar), 0);
			for (j=0, length=0; bsdPathZ[j] !=0; ++j ) ++length;
			//		for (j=0, length=0; bsdPathX[j] !=0; ++j ) ++length;
			//      strcpy(bytes, bsdPathX);
			for ( j=8; j<length; j++ )	
			{
				bytes[j-8]=bsdPathZ[j];
				//			bytes[j-8]=bsdPathX[j];
			}
			bytes[length-8]='\0';  
			
			for ( j=0; j<5; j++ )	
			{
				strAllport[findPortCountX-1][j]=bytes[j];
			}
			strAllport[findPortCountX-1][5]='\0';  
			
			for (j=0, length=0; bytes[j] !=0; ++j ) ++length;
			
			for ( j=0; j<length; j++ )	
			{
				strAllportName[findPortCountX-1][j]=bytes[j];
			}
			strAllportName[findPortCountX-1][length]='\0';  
			
			
			if (findPortCountX ==  1) str1  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  2) str2  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  3) str3  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  4) str4  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  5) str5  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  6) str6  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  7) str7  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  8) str8  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  9) str9  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  10) str10  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  11) str11  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			else if (findPortCountX ==  12) str12  = (NSString*)CFStringCreateWithCStringNoCopy(NULL, bytes, kCFStringEncodingASCII, NULL);
			
			/*
			 if (findPortCountX ==  1) str1  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  2) str2  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  3) str3  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  4) str4  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  5) str5  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  6) str6  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  7) str7  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  8) str8  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  9) str9  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  10) str10  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  11) str11  =  [NSString stringWithFormat:@"%s", bytes];
			 else if (findPortCountX ==  12) str12  =  [NSString stringWithFormat:@"%s", bytes];
			 */
			
			
			printf("out : %s\n", bsdPathZ);
			
		}
		
		
	}
	

	findPortCountX =  [self SerialGetPort:1 CH:bsdPathZ];	// when 1 then 1st one, 
	
	printf("after findPortCountX in setGetINPort: %d\n", findPortCountX);	
	
	// 	titlesAllPortName = [NSArray arrayWithObjects: str1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, nil];
	
	
	
//    NSArray *titlesOutPort = [NSArray arrayWithObjects: str1, str2, str3, str4, str5, str6, str7, str8, str9, str10, str11, str12, nil];
	//    NSEnumerator *titleEnumOutPort = [titlesOutPort objectEnumerator];
	//    id titleOutPort = nil;
	//   [popupOutPort removeAllItems];
	//   while (titleOutPort = [titleEnumOutPort nextObject]) {
	//       [popupOutPort addItemWithTitle:titleOutPort];
	//   }
	
	
	//       CFRelease(str1); CFRelease(str2); CFRelease(str3); CFRelease(str4); CFRelease(str5); CFRelease(str6);
	//       CFRelease(str7); CFRelease(str8); CFRelease(str9); CFRelease(str10); CFRelease(str11); CFRelease(str12);
	
	
	//	printf("setGetINPort = %d\n", SelectDevice );
	
	return findPortCount;
	

}


//
// this is 1st step to re-load modem name and number fo modem
//
- (int) SerialGetPort:(int) selectPortN CH:(char *) Cstr
{
    kern_return_t	kernResult; // on PowerPC this is an int (4 bytes)
	
	//	[self initbitrevAndFFT];
	/*
	 /*
	 *	error number layout as follows (see mach/error.h):
	 *
	 *	hi		 		       lo
	 *	| system(6) | subsystem(12) | code(14) |
	 */
	
    io_iterator_t	serialPortIterator;
    char		bsdPath[MAXPATHLEN];
    int findPort = 0;    
	
    kernResult = FindModems(&serialPortIterator);
    
    kernResult = GetModemPath(serialPortIterator, bsdPath, sizeof(bsdPath), selectPortN);
    
    IOObjectRelease(serialPortIterator);	// Release the iterator.
	
	printf("after IOObjectRelease\n");
	
	
    // Now open the modem port we found, initialize the modem, then close it
    if (!bsdPath[0])
    {
        printf("No modem port found.\n");
    }
	else  findPort = modemN; 
	
 	strcpy(Cstr, bsdPath);
	
	//
	// this is  god
	//
	/*  
	 for (i=0, length=0; bsdPath[i] !=0; ++i ) ++length;
	 for ( i=0; i<length; i++ )
	 {
	 Cstr[i]=bsdPath[i];
	 }
	 Cstr[sizeof(bsdPath)]='\0';
	 */
	

	
	return findPort;
} // end of int SerialGetPot(void)



//
// add '\r' to input str
//
-(void) NSStringToCX1:(NSString *)NSStringC
{
	if ([ NSStringC  cString ] == nil ) goto UFO;
	
	char  *outCHARX;
	int i=0;
	int slen=strlen([ NSStringC  cString ]);
	
	
 	outCHARX=(char  *)[NSStringC cString];
	
	for (i=0; i<slen; i++)
		bufferInputCX1[i]=outCHARX[i];
	
//	bufferInputCX1[slen]='\0';

 	bufferInputCX1[slen]='\r';
	 	bufferInputCX1[slen+1]='\0';
	
	goto IFO;
	
UFO:
	bufferInputCX1[0]='\0';
	
IFO:
	i=0;
}


//
// add /dev/cu. to input name of port
//
-(void) NSStringToCX:(NSString *)NSStringC
{
	if ([ NSStringC  cString ] == nil ) goto UFO;
	
	char  *outCHARX;
	int i=0;
	int slen=strlen([ NSStringC  cString ]);
	
	
 	outCHARX=(char  *)[NSStringC cString];
	
	bufferInputCX[0]='/';
	bufferInputCX[1]='d';
	bufferInputCX[2]='e';
	bufferInputCX[3]='v';
	bufferInputCX[4]='/';
	bufferInputCX[5]='c';
	bufferInputCX[6]='u';
	bufferInputCX[7]='.';
	
	for (i=0; i<slen; i++)
		bufferInputCX[i+8]=outCHARX[i];
	
	
	bufferInputCX[slen+8]='\0';
	
	goto IFO;
	
UFO:
	bufferInputCX[0]='\0';
	
IFO:
	i=0;
}





@end





@implementation IBVASerialPortPlugIn (Execution)




- (BOOL) startExecution:(id<QCPlugInContext>)context
{
	if (firsttimestartmainloop)	{

		printf("startExecution\n");
		firsttimestartmainloop=0;
	}
	
	//
	//
	return YES;
}

- (BOOL) execute:(id<QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary*)arguments
{
	
 	NSString *AX;

	//
	//
	//
	CGLContextObj					cgl_ctx = [context CGLContextObj];
	id<QCPlugInInputImageSource>	image;
	GLuint							textureName;
	GLint							saveMode,
	saveName;
	GLboolean						saveEnabled;
	const CGFloat*					colorComponents;
	GLenum							error;
	
	if(cgl_ctx == NULL)
		return NO;
	
	/* Copy the image on the "inputImage" input port to a local variable */
	image = self.inputImage;
	
	/* Get a texture from the image in the context colorspace */
	if(image && [image lockTextureRepresentationWithColorSpace:([image shouldColorMatch] ? [context colorSpace] : [image imageColorSpace]) forBounds:[image imageBounds]])
		textureName = [image textureName];
	else
		textureName = 0;
	
	/* Save and set modelview matrix */
	glGetIntegerv(GL_MATRIX_MODE, &saveMode);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(self.inputX, self.inputY, 0.0);
	
	/* Bind texture to unit */
	if(textureName)
		[image bindTextureRepresentationToCGLContext:cgl_ctx textureUnit:GL_TEXTURE0 normalizeCoordinates:YES];
	
	/* Get RGBA components from the color on the "inputColor" input port (the CGColorRef is guaranteed to be of type RGBA) */
	colorComponents = CGColorGetComponents(self.inputColor);
	
	/* Set current color (no need to save / restore as the current color is part of the GL_CURRENT_BIT) */
	glColor4f(colorComponents[0], colorComponents[1], colorComponents[2], colorComponents[3]);
	
	/* Render textured quad (we can use normalized texture coordinates independently of the texture target or the texture vertical flipping state thanks to -bindTextureRepresentationToCGLContext) */
	glBegin(GL_QUADS);
	glTexCoord2f(1.0, 1.0);
	glVertex3f(0.5, 0.5, 0);
	glTexCoord2f(0.0, 1.0);
	glVertex3f(-0.5, 0.5, 0);
	glTexCoord2f(0.0, 0.0);
	glVertex3f(-0.5, -0.5, 0);
	glTexCoord2f(1.0, 0.0);
	glVertex3f(0.5, -0.5, 0);
	glEnd();
	
	/* Unbind texture from unit */
	if(textureName)
		[image unbindTextureRepresentationFromCGLContext:cgl_ctx textureUnit:GL_TEXTURE0];
	
	/* Restore modelview matrix */
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	glMatrixMode(saveMode);
	
	/* Check for OpenGL errors */
	if(error = glGetError())
		[context logMessage:@"OpenGL error %04X", error];
	
	/* Release texture */
	if(textureName)
		[image unlockTextureRepresentation];
	

//
	//
	//
	//

 	
	
	if ( self.inputUpdate )	{	// 
		
	//
	//
	if ( inputPortS!=self.inputPortON)	{
		
		if ( self.inputPortON )	{

			[self setBluetoothDeviceSelection];
			[[RFCOMMSPPController sharedRFCOMMSPPController] sendSampleSpeedBluetooth:120];

		}
		else	{
			[self setBluetoothDeviceClose];
		}
			
		inputPortS=self.inputPortON;
		
	}
		
	

		
		if ( self.inputSendText==TRUE   ) {
			
	  		self.outputString =  [NSString stringWithFormat:@"%s", bufferInputCX2 ];
	  		self.outputAString =  [NSString stringWithFormat:@"%s", bufferInputCX2A ];
	  		self.outputBString =  [NSString stringWithFormat:@"%s", bufferInputCX2B ];
	  		self.outputCString =  [NSString stringWithFormat:@"%s", bufferInputCX2C ];
	  		self.outputDString =  [NSString stringWithFormat:@"%s", bufferInputCX2D ];
	//	  	printf("printHNumber2= %s\n", bufferInputCX2); 
	//		printf("printHNumber2A= %s\n", bufferInputCX2A); 
	//		printf("printHNumber2B= %s\n", bufferInputCX2B); 
	//		printf("printHNumber2C= %s\n", bufferInputCX2C); 
	//		printf("printHNumber2D= %s\n", bufferInputCX2D); 
			bufferXcount=0;
			bufferXcountB=0;
			bufferXcountB1=0;
			bufferXcountB2=0;
			bufferXcountB3=0;
			bufferXcountB4=0;
			//
			// 
			//
			
			SendText=0;
			
		}
		else if ( self.inputSendText==0 ) {
			SendText=1;
			self.outputString = @"";
			self.outputAString = @"";
			self.outputBString = @"";
			self.outputCString = @"";
			self.outputDString = @"";
		}
		
		
		
		if ( OutputFormatX!=(int)self.inputOutputFormat)	{
			OutputFormatX=(int)self.inputOutputFormat;
			

			[[RFCOMMSPPController sharedRFCOMMSPPController] setOutputFormatZ:OutputFormatX];
			
			
		}
		
		if ( DelimiterX!=(int)self.inputDelimiter)	{
			DelimiterX=(int)self.inputDelimiter;
			
			[[RFCOMMSPPController sharedRFCOMMSPPController] setDelimiter:DelimiterX];
			
		}
		

		
	
	} // end of if ( self.inputUpdate )

 
	//
	//
		return (error ? NO : YES);
//	return YES;
}





- (void) setBluetoothDeviceSelection	{

	
	[[RFCOMMSPPController sharedRFCOMMSPPController] openSerialPortConnection];
	
	
}


- (void) setBluetoothDeviceClose	{
	
	[[RFCOMMSPPController sharedRFCOMMSPPController] closePortConnection];
	
}





@end








